"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _timeFormatters = require("./timeFormatters");

var _unitFormatters = require("./unitFormatters");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n      text-transform: uppercase;\n      font-size: ", "px;\n    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n      align-items: center;\n      background: ", ";\n      border-radius: 50%;\n      box-sizing: border-box;\n      color: ", ";\n      display: flex;\n      flex-flow: column;\n      font-family: ", ";\n      font-size: ", "px;\n      font-weight: ", ";\n      height: ", "px;\n      justify-content: center;\n      text-align: center;\n      text-transform: uppercase;\n      width: ", "px;\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n      align-items: center;\n      background-image: linear-gradient(\n          ", "deg,\n          ", " 50%,\n          transparent 50%\n        ),\n        linear-gradient(\n          ", "deg,\n          ", " 50%,\n          ", " 50%\n        );\n      border-radius: 50%;\n      display: flex;\n      height: ", "px;\n      justify-content: center;\n      width: ", "px;\n    "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Countdown360 =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Countdown360, _React$Component);

  function Countdown360(props) {
    var _this;

    _classCallCheck(this, Countdown360);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Countdown360).call(this, props));
    var seconds = Math.max(props.seconds, 0);
    var secondsLeft = props.startingSecond && props.startingSecond > 0 ? Math.min(seconds, props.startingSecond) : seconds;
    _this.state = {
      totalSeconds: seconds,
      secondsLeft: secondsLeft * 1000,
      started: false,
      lastTick: null
    };
    _this.interval = null;
    _this.handleTick = _this.handleTick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Countdown360, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var autoStart = this.props.autoStart;

      if (autoStart) {
        this.start();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearInterval(this.interval);
      this.interval = null;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var smooth = this.props.smooth;

      if (prevProps.smooth !== smooth) {
        clearInterval(this.interval);
        this.interval = setInterval(this.handleTick, smooth ? 16 : 1000);
      }
    }
  }, {
    key: "extendTimer",
    value: function extendTimer(value) {
      var _this$state = this.state,
          secondsLeft = _this$state.secondsLeft,
          totalSeconds = _this$state.totalSeconds;
      totalSeconds += value;
      totalSeconds = Math.max(totalSeconds, 0);
      secondsLeft = Math.min(secondsLeft, totalSeconds * 1000);
      this.setState({
        secondsLeft: secondsLeft,
        totalSeconds: totalSeconds
      });
    }
  }, {
    key: "addSeconds",
    value: function addSeconds(value) {
      var _this$state2 = this.state,
          secondsLeft = _this$state2.secondsLeft,
          totalSeconds = _this$state2.totalSeconds;
      value *= 1000;
      this.setState({
        secondsLeft: Math.max(Math.min(secondsLeft + value, totalSeconds * 1000), 0)
      });
    }
  }, {
    key: "start",
    value: function start() {
      var _this$state3 = this.state,
          secondsLeft = _this$state3.secondsLeft,
          started = _this$state3.started;

      if (started || secondsLeft <= 0) {
        return;
      }

      var smooth = this.props.smooth;
      var timerInterval = smooth ? 16 : 1000;
      this.handleTick();
      this.interval = setInterval(this.handleTick, timerInterval);
      this.setState({
        started: true
      });
    }
  }, {
    key: "stop",
    value: function stop() {
      var started = this.state.started;

      if (!started) {
        return;
      }

      clearInterval(this.interval);
      this.interval = null;
      this.handleTick();
      this.setState({
        started: false,
        lastTick: null
      });
    }
  }, {
    key: "handleTick",
    value: function handleTick() {
      var _this2 = this;

      var _this$state4 = this.state,
          secondsLeft = _this$state4.secondsLeft,
          started = _this$state4.started;

      if (!started || secondsLeft <= 0) {
        return;
      }

      var now = new Date();
      var lastTick = this.state.lastTick || now;
      var diff = Math.abs(now - lastTick);
      var updatedSecondsLeft = Math.max(secondsLeft - diff, 0);
      this.setState({
        lastTick: now,
        secondsLeft: updatedSecondsLeft
      }, function () {
        if (updatedSecondsLeft <= 0) {
          var onComplete = _this2.props.onComplete;
          onComplete && onComplete();

          _this2.stop();
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          clockwise = _this$props.clockwise,
          smooth = _this$props.smooth,
          startingAngle = _this$props.startingAngle,
          width = _this$props.width;
      var _this$props2 = this.props,
          backgroundColor = _this$props2.backgroundColor,
          borderUnfillColor = _this$props2.borderUnfillColor,
          borderFillColor = _this$props2.borderFillColor,
          borderWidth = _this$props2.borderWidth;
      var _this$props3 = this.props,
          fontColor = _this$props3.fontColor,
          fontFamily = _this$props3.fontFamily,
          fontSize = _this$props3.fontSize,
          fontWeight = _this$props3.fontWeight,
          timeFormatter = _this$props3.timeFormatter,
          unitFormatter = _this$props3.unitFormatter;
      var _this$state5 = this.state,
          secondsLeft = _this$state5.secondsLeft,
          totalSeconds = _this$state5.totalSeconds;
      var angle;

      if (!smooth) {
        angle = Math.round(secondsLeft / 1000) / totalSeconds * 360;
      } else {
        angle = secondsLeft / (totalSeconds * 1000) * 360;
      }

      var factor = clockwise ? -1 : 1;
      var x = (angle >= 180 ? 90 - (360 - angle) : 90) * factor + startingAngle;
      var y = (angle >= 180 ? 90 : -90 + angle) * factor + startingAngle;

      var Wrapper = _styledComponents["default"].div(_templateObject(), x, angle >= 180 ? borderFillColor : borderUnfillColor, y, borderUnfillColor, borderFillColor, width, width);

      var Label = _styledComponents["default"].div(_templateObject2(), backgroundColor, fontColor, fontFamily, fontSize, fontWeight, width - 2 * borderWidth, width - 2 * borderWidth);

      var Unit = _styledComponents["default"].div(_templateObject3(), fontSize / 3);

      var value = timeFormatter(secondsLeft);
      var unit = unitFormatter(value);
      return _react["default"].createElement(Wrapper, null, _react["default"].createElement(Label, null, value, _react["default"].createElement("br", null), _react["default"].createElement(Unit, null, unit)));
    }
  }]);

  return Countdown360;
}(_react["default"].Component);

Countdown360.defaultProps = {
  autoStart: true,
  backgroundColor: '#fff',
  borderFillColor: '#f11',
  borderUnfillColor: '#e6e2e7',
  borderWidth: 20,
  clockwise: false,
  fontColor: '#111',
  fontFamily: 'sans-serif',
  fontSize: 45,
  fontWeight: 700,
  smooth: false,
  startingAngle: 0,
  timeFormatter: _timeFormatters.timeFormatterSeconds,
  unitFormatter: _unitFormatters.unitFormatterSeconds,
  width: 200
};
Countdown360.propTypes = {
  autoStart: _propTypes["default"].bool,
  backgroundColor: _propTypes["default"].string,
  borderFillColor: _propTypes["default"].string,
  borderUnfillColor: _propTypes["default"].string,
  borderWidth: _propTypes["default"].number,
  clockwise: _propTypes["default"].bool,
  fontColor: _propTypes["default"].string,
  fontFamily: _propTypes["default"].string,
  fontSize: _propTypes["default"].number,
  fontWeight: _propTypes["default"].number,
  onComplete: _propTypes["default"].func,
  seconds: _propTypes["default"].number.isRequired,
  smooth: _propTypes["default"].bool,
  startingAngle: _propTypes["default"].number,
  startingSecond: _propTypes["default"].number,
  timeFormatter: _propTypes["default"].func,
  unitFormatter: _propTypes["default"].func,
  width: _propTypes["default"].number
};
var _default = Countdown360;
exports["default"] = _default;