"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.timeFormatterSeconds = exports.timeFormatterDigitalClock = void 0;

// a time formatter is a function that takes a single argument, being the number
// of milliseconds left, and returns the number to show on the countdown
var timeFormatterDigitalClock = function timeFormatterDigitalClock(timeLeft) {
  timeLeft = Math.round(timeLeft / 1000);
  var seconds = timeLeft % 60;
  var minutes = (timeLeft - seconds) / 60;
  return "".concat(minutes.toString().padStart(2, '0'), ":").concat(seconds.toString().padStart(2, '0'));
};

exports.timeFormatterDigitalClock = timeFormatterDigitalClock;

var timeFormatterSeconds = function timeFormatterSeconds(timeLeft) {
  return Math.round(timeLeft / 1000);
};

exports.timeFormatterSeconds = timeFormatterSeconds;